#script permitting to make the correspondancy between smoothing
#parmeter and equivalent degree of freedom

  
require(MASS)


#geometric mean
gm_mean = function(x, na.rm=TRUE, zero.propagate = FALSE){
  if(any(x < 0, na.rm = TRUE)){
    return(NaN)
  }
  if(zero.propagate){
    if(any(x == 0, na.rm = TRUE)){
      return(0)
    }
    exp(mean(log(x), na.rm = na.rm))
  } else {
    exp(sum(log(x[x > 0]), na.rm=na.rm) / length(x))
  }
}



dlrho = function(dl,letter){
 
#   if(letter=="p"){
#   source("BaseSplinePer.R",local=F);
#   }
  
  vrho0 = c(1 ,100)
  while( (vrho0[2] / vrho0[1]) > 1.0001) {
    vrho = dl_dich(vrho0,dl,letter)
    vrho0 = vrho
    #cat(vrho,"\n")
  }
  
  rho = gm_mean(vrho0)
  return(rho )
}


#functions wich produces a dichotomy between different value of 
#the smoothing parameters

dl_dich=function(v0,dl,letter){
  
  dl1 = rhodl(v0[1],letter);
  dl0 = rhodl(v0[2],letter);
  if (dl > dl1) {
    y0 = v0[1]^2/v0[2];
    y1 = v0[1]
  }
  else if (dl < dl0){
    y0 = v0[2];
    y1 = v0[2]^2/v0[1];}
  else{
    y0 = v0[1];
    y1 = gm_mean(v0);
  }
  vrho = c(y0,y1);
  return(vrho)
}



#computes the equivalent degrees of freedom for a given value 
#of the smoothing parameters

rhodl = function(rho,letter){
  if(letter=="p"){
    H=t(Zp)%*%Zp + rho * Gp
    dl=sum(diag(Zp%*%solve(H)%*%t(Zp)))}
     return(dl)
}

